searchNodes=[{"doc":"When use-ed in a module that also use-es Ecto.Repo, augments the following Ecto.Repo callbacks to provide user definable hooks following successful execution.Hooks to MyApp.EctoSchema.after_get/1:all/2get/3get!/3get_by/3get_by!/3one/2one!/2Hooks to MyApp.EctoSchema.after_delete/1:delete/2delete!/2Hooks to MyApp.EctoSchema.after_insert/1:insert/2insert!/2Hooks to MyApp.EctoSchema.after_update/1:update/2update!/2Hooks to MyApp.EctoSchema.after_insert/1 or to MyApp.Ecto.Schema.after_update/1:insert_or_update/2insert_or_update!/2Hooks to MyApp.EctoSchema.before_delete/1:delete/2delete!/2Hooks to MyApp.EctoSchema.before_insert/1:insert/2insert!/2Hooks to MyApp.EctoSchema.before_update/1:update/2update!/2Hooks to MyApp.EctoSchema.before_insert/1 or to MyApp.Ecto.Schema.before_update/1:insert_or_update/2insert_or_update!/2Please note that for all after_* hooks, the result of executing a MyApp.Repo.* callback is what ultimately gets returned from the hook, and thus you should aim to write logic that is transparent and does not break the expected semantics or behaviour of said callback.Any results wrapped within an {:ok, _} or {:error, _} are also returned re-wrapped as expected.For all before_* hooks, the result returned by hook is passed directly to the MyApp.Repo.* callback called and thus care must be made to be aware of any implicit changes to changesets prior to writing to the database.The hooking functionality provided by EctoHooks can be pretty useful for resolving virtual fields, but can also prove useful for centralising some logging or telemetry logic. Note that because any business logic is executed synchronously after the hooked Ecto.Repo callback, one should avoid doing any blocking or potentially terminating logic within hooks as weird or strange behaviour may occur.Example usage:def MyApp.Repo do use Ecto.Repo, otp_app: :my_app, adapter: Ecto.Adapters.Postgres use EctoHooks end def MyApp.User do use Ecto.Changeset require Logger schema &quot;users&quot; do field :first_name, :string field :last_name, :string field :full_name, :string, virtual: true end def before_insert(changeset) do Logger.warning(&quot;updating a user...&quot;) changeset end def after_get(%__MODULE__{first_name: first_name, last_name: last_name} = user) do %__MODULE__{user | full_name: first_name &lt;&gt; &quot; &quot; &lt;&gt; last_name} end end","ref":"EctoHooks.html","title":"EctoHooks","type":"module"},{"doc":"This module provides an alternate interface for initializing EctoHooks.Ordinarily, one would need to add the use EctoHooks statement to an Ecto.Repo implementation module in one's application.This module instead simply replaces the use Ecto.Repo, ... statement with the following:defmodule MyApp.Repo do use EctoHooks.Repo, otp_app: :my_app, ... endAny paramters passed into use EctoHooks.Repo are simply forwarded to Ecto.Repo and EctoHooks functionality is automatically included.See the documentation to EctoHooks for more information.","ref":"EctoHooks.Repo.html","title":"EctoHooks.Repo","type":"module"}]